#include "config.h"
#include <stdio.h>
#include "assert_demos.h"

FILE *fp;

int main()
{
	unsigned char buf[16] = "abcdefghijklmnop";
	char str[64];

	fp = fopen("D:\\aaa.txt","w+");
	if (!fp)
	{
		puts("Cannot open file");
		return -1;
	}


	// Test to write string to file
	fwrite (buf , sizeof(char), sizeof(buf), fp);

	printf("\n\r");
	printf(">>> demo printf: start <<<\n\r");
	printf("if you see all messages in UPPER case, then nds_write() is overridden!\n\r");
	printf("=== demo printf: end ===\n\r");


	// Test to read string from file
	fseek (fp , 0 , SEEK_SET );
	fscanf (fp, "%s", str);
	printf("%s", str);


	fclose (fp);

	while (1) ;
}

/*
 * override putchar
 */
#include "config.h"
#if defined(CFG_AG102)
#include "ag102.h"
#elif defined(CFG_AE210P)
#include "ae210p.h"
#else
#include "ag101p.h"
#endif

#include <ctype.h> /* for toupper() */

#undef putchar
inline int putchar(int c)
{
	c = toupper(c);

	/* tx fifo full */
	while ((inw(UART_BASE + UART_LSR_OFFSET) & 0x20) == 0);
	outw(UART_BASE + UART_THR_OFFSET, c);
	return c;
}

void nds_write(const unsigned char *buf, int size)
{
	if (!fp)
	{
		int    i;
		for (i = 0; i < size; i++)
			putchar(buf[i]);
	}
	else
	{
		fwrite (buf , sizeof(char), size, fp);
	}

}
